//~~~~~THIS FILE IS DESIGNED TO TEST VARIOUS~~~~~\\
//~~~~~PARTS OF THE ZEPPELIN SCENE~~~~~\\
//~~~~~ALL INFORMATION HEREIN IS COPYRIGHT~~~~~\\
//~~~~~DAVID R. HEYS, 1997-1998~~~~~\\

#version 3.0
global_settings { assumed_gamma 2.1 }

#include "colors.inc"
#include "textures.inc"
#include "Zeppelin.inc"
#include "Engine.inc"
#include "Hangar2.inc"
#include "World.inc"
#include "Concrete.inc"

#declare Canvas1=
  texture {pigment {color rgb<0.847, 0.847, 0.749>}}
  texture {
    pigment {
        color rgbft<0.847, 0.847, 0.749, 0.5, 0.25>
    }
    normal {
      quilted
      control1 0
      control0 1
      turbulence 0
      rotate <10, 20, 30>
      scale <0.2, 0.07, 0.2>
    }
  }
  texture {
    pigment {
      image_map {
        gif
        "c:/images/zeppelin/usnavy4.gif"
        once
        transmit 52, 0.75
        filter 52, 0.75
      }
      translate <-0.5, -0.5, 0>
      rotate <0, -90, 0>
      scale 3
      translate <0, 0, -0.5>
      scale 5
    }
    normal {
      quilted
      control1 0
      control0 1
      turbulence 0
      rotate <15, -20, -35>
      scale <0.07, 0.02, 0.02>
    }
  }

#declare Canvas=
  texture {pigment {color rgb<0.847, 0.847, 0.749>}}
  texture {
    pigment {
        color rgbft<0.847, 0.847, 0.749, 0.5, 0.25>
    }
    normal {
      quilted
      control1 0
      control0 1
      turbulence 0
      rotate <10, 20, 30>
      scale <0.2, 0.07, 0.2>
    }
  }
  texture {
    pigment {
        color rgbft<0.847, 0.847, 0.749, 0.5, 0.25>
    }
    normal {
      quilted
      control1 0
      control0 1
      turbulence 0
      rotate <-30, -20, -10>
      scale <0.07, 0.02, 0.02>
    }
  }

camera {
  right <4/3, 0, 0>
  up <0, 1, 0>
  sky <0, 1, 0>
  direction <0, 0, 1.5>
  location <25, -3, -28>
  look_at <2.75, -1.25, -2>
}

light_source { <5000, 5000, -5000> color rgb<1.5, 1.5, 1.45>}

#declare Rope=
torus {1, .1
  rotate <0, 0, -90>
  clipped_by {
    box{<-2, -2, -2>, <2, 0, 2>}
  }
  scale <1, 1, 18>
  translate <0, 1.5, 20.75>
  texture {
    pigment {
      spiral1 1
      color_map {
        [0.0, rgb<0.5, 0.4, 0.2>]
        [1.0, rgb<0.2, 0.15, 0.1>]
      }
    }
    scale 0.5
    rotate <115, 0, 0>
  }
}

object {Hangar_Roof}

object {Left_Door}

object {Right_Door}

object {Back_Door1}

object {Back_Door2}

object {Sky_Obj}

object {Ground}

object {Concrete}

object {Right_Wall}

object {Left_Wall}

object {Right_Glass}

object {Left_Glass}

object {Rope}

// MAIN AIRSHIP

object {Prop1
  translate <0, 1.5, -3>
}
object {Prop2
  translate <0, 1.5, -3>
}
object {Prop3
  translate <0, 1.5, -3>
}
object {Prop4
  translate <0, 1.5, -3>
}
object {Rudder
  translate <0, 1, -9.25>
  translate <0, 1.5, 0>
}
object {Rudder
  translate <0, 1, -9.25>
  rotate <0, 0, 90>
  translate <0, 1.5, 0>
}
object {Rudder
  translate <0, 1, -9.25>
  rotate <0, 0, -90>
  translate <0, 1.5, 0>
}
object {Rudder
  translate <0, 1, -9.25>
  rotate <0, 0, 180>
  translate <0, 1.5, 0>
}
object {Gondola
  scale 0.5
  translate <0, 0, -3.5>
  translate <0, -1.0, 0>
}
object {Zeppelin1
  texture {Canvas1}
  translate <0, 1.5, -3>
}


// AIRSHIP FAR OFF IN THE SKY

object {Prop1
  translate <0, 1.5, -3>
  rotate <-22, -100, 0>
  translate <-115, 50, 70>
}
object {Prop2
  translate <0, 1.5, -3>
  rotate <-22, -100, 0>
  translate <-115, 50, 70>
}
object {Prop3
  translate <0, 1.5, -3>
  rotate <-22, -100, 0>
  translate <-115, 50, 70>
}
object {Prop4
  translate <0, 1.5, -3>
  rotate <-22, -100, 0>
  translate <-115, 50, 70>
}
object {Rudder
  translate <0, 1, -9.25>
  translate <0, 1.5, 0>
  rotate <-22, -100, 0>
  translate <-115, 50, 70>
}
object {Rudder
  translate <0, 1, -9.25>
  rotate <0, 0, 90>
  translate <0, 1.5, 0>
  rotate <-22, -100, 0>
  translate <-115, 50, 70>
}
object {Rudder
  translate <0, 1, -9.25>
  rotate <0, 0, -90>
  translate <0, 1.5, 0>
  rotate <-22, -100, 0>
  translate <-115, 50, 70>
}
object {Rudder
  translate <0, 1, -9.25>
  rotate <0, 0, 180>
  translate <0, 1.5, 0>
  rotate <-22, -100, 0>
  translate <-115, 50, 70>
}
object {Gondola
  scale 0.5
  translate <0, 0, -3.5>
  translate <0, -1.0, 0>
  rotate <-22, -100, 0>
  translate <-115, 50, 70>
}
object {Zeppelin1
  texture {Canvas1}
  translate <0, 1.5, -3>
  rotate <-22, -100, 0>
  translate <-115, 50, 70>
}
